# DidwwUps::Base class base class for API resources
module DidwwUps
  class Base < ActiveResource::Base

    self.include_format_in_path = false
    self.prefix = "/api/rest/v1/"
    add_response_method :http

    self.collection_parser = DidwwUps::Collection

    delegate :[], to: :@attributes

    def remote_errors_response
      instance_variable_get(:@remote_errors).try(:response)
    end

    class << self

      def site=(site)
        site_uri = create_site_uri_from(site)
        @site = site_uri
        Thread.current['didww_ups.site'] = site_uri
      end

      def site
        Thread.current['didww_ups.site'] || @site
      end

      #no headers
      def headers
        {}
      end

      #override with needed Connection class
      def connection(refresh = false)
          @connection = DidwwUps::Connection.new(DidwwUps::Base.site, format) if refresh || @connection.nil?
          @connection.timeout = timeout if timeout
          @connection.ssl_options = ssl_options if ssl_options
          @connection
      end
    end
  end
end